Package org.apache.sling.scripting.javascript.wrapper

# Class ScriptableProperty

java.lang.Object
org.mozilla.javascript.ScriptableObject
org.apache.sling.scripting.javascript.wrapper.ScriptableBase
org.apache.sling.scripting.javascript.wrapper.ScriptableProperty

All Implemented Interfaces:
  `Serializable`, `SlingWrapper`, `org.mozilla.javascript.ConstProperties`, `org.mozilla.javascript.debug.DebuggableObject`, `org.mozilla.javascript.Scriptable`, `org.mozilla.javascript.Wrapper`

public class ScriptableProperty extends ScriptableBase implements SlingWrapper
Wrap a JCR Property as a Scriptable

See Also:
  - Serialized Form

## Field Summary

Fields
Modifier and Type
Field
Description
`static final String`
`CLASSNAME`

### Fields inherited from class org.apache.sling.scripting.javascript.wrapper.ScriptableBase

`JSFUNC_PREFIX`

### Fields inherited from class org.mozilla.javascript.ScriptableObject

`CONST, DONTENUM, EMPTY, PERMANENT, READONLY, UNINITIALIZED_CONST`

### Fields inherited from interface org.mozilla.javascript.Scriptable

`NOT_FOUND`

## Constructor Summary

Constructors
Constructor
Description
`ScriptableProperty()`

## Method Summary

Modifier and Type
Method
Description
`Object`
`get(String name, org.mozilla.javascript.Scriptable start)`
`String`
`getClassName()`
The name of the JavaScript host object "class".
`protected Class<?>`
`getStaticType()`
`int`
`getType()`
`Class<?>[]`
`getWrappedClasses()`
The list of Java classes wrapped by this wrapper.
`protected Object`
`getWrappedObject()`
`void`
`jsConstructor(Object res)`
`Object`
`jsFunction_toString()`
`Object`
`jsFunction_valueOf(String hint)`
`Object`
`jsGet_boolean()`
`Object`
`jsGet_date()`
`Object`
`jsGet_definition()`
`int`
`jsGet_depth()`
`Object`
`jsGet_double()`
`Object`
`jsGet_length()`
`long[]`
`jsGet_lengths()`
`Object`
`jsGet_long()`
`boolean`
`jsGet_modified()`
`String`
`jsGet_name()`
`boolean`
`jsGet_new()`
`Object`
`jsGet_node()`
`Object`
`jsGet_parent()`
`String`
`jsGet_path()`
`Object`
`jsGet_session()`
`Object`
`jsGet_stream()`
`Object`
`jsGet_string()`
`Object`
`jsGet_value()`
`Object`
`jsGet_values()`
`String`
`toString()`
`Object`
`unwrap()`

### Methods inherited from class org.apache.sling.scripting.javascript.wrapper.ScriptableBase

`getNative`

### Methods inherited from class org.mozilla.javascript.ScriptableObject

`applyDescriptorToAttributeBitset, associateValue, avoidObjectDetection, buildDataDescriptor, callMethod, callMethod, checkPropertyChange, checkPropertyDefinition, defineClass, defineClass, defineClass, defineConst, defineConstProperty, defineFunctionProperties, defineOwnProperties, defineOwnProperty, defineOwnProperty, defineProperty, defineProperty, defineProperty, defineProperty, delete, delete, deleteProperty, deleteProperty, ensureScriptable, ensureScriptableObject, equivalentValues, get, get, getAllIds, getArrayPrototype, getAssociatedValue, getAttributes, getAttributes, getAttributes, getAttributes, getClassPrototype, getDefaultValue, getDefaultValue, getExternalArrayData, getExternalArrayLength, getFunctionPrototype, getGetterOrSetter, getIds, getObjectPrototype, getOwnPropertyDescriptor, getParentScope, getProperty, getProperty, getPropertyIds, getPrototype, getSlot, getTopLevelScope, getTopScopeValue, getTypedProperty, getTypedProperty, getTypeOf, has, has, hasInstance, hasProperty, hasProperty, isAccessorDescriptor, isConst, isDataDescriptor, isEmpty, isExtensible, isFalse, isGenericDescriptor, isGetterOrSetter, isSealed, isTrue, preventExtensions, put, put, putConst, putConstProperty, putProperty, putProperty, redefineProperty, sameValue, sealObject, setAttributes, setAttributes, setAttributes, setAttributes, setExternalArrayData, setGetterOrSetter, setParentScope, setPrototype, size`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

## Field Details

### CLASSNAME

public static final String CLASSNAME

See Also:
  - Constant Field Values

## Constructor Details

### ScriptableProperty

public ScriptableProperty()

## Method Details

### jsConstructor

public void jsConstructor(Object res)

### getClassName

public String getClassName()
Description copied from interface: `SlingWrapper`
The name of the JavaScript host object "class".

Specified by:
  `getClassName` in interface `org.mozilla.javascript.Scriptable`
Specified by:
  `getClassName` in interface `SlingWrapper`
Specified by:
  `getClassName` in class `org.mozilla.javascript.ScriptableObject`
Returns:
  the class name

### getWrappedClasses

public Class<?>[] getWrappedClasses()
Description copied from interface: `SlingWrapper`
The list of Java classes wrapped by this wrapper.

Specified by:
  `getWrappedClasses` in interface `SlingWrapper`
Returns:
  the wrapped classes

### jsGet_value

public Object jsGet_value()

### jsGet_values

public Object jsGet_values()

### jsGet_string

public Object jsGet_string()

### jsGet_stream

public Object jsGet_stream()

### jsGet_long

public Object jsGet_long()

### jsGet_double

public Object jsGet_double()

### jsGet_date

public Object jsGet_date()

### jsGet_boolean

public Object jsGet_boolean()

### jsGet_node

public Object jsGet_node()

### jsGet_length

public Object jsGet_length()

### jsGet_lengths

public long[] jsGet_lengths()

### jsGet_definition

public Object jsGet_definition()

### getType

public int getType()

### jsGet_session

public Object jsGet_session()

### jsGet_path

public String jsGet_path()

### jsGet_name

public String jsGet_name()

### jsGet_parent

public Object jsGet_parent()

### jsGet_depth

public int jsGet_depth()

### jsGet_new

public boolean jsGet_new()

### jsGet_modified

public boolean jsGet_modified()

### jsFunction_valueOf

public Object jsFunction_valueOf(String hint)

### get

public Object get(String name, org.mozilla.javascript.Scriptable start)

Specified by:
  `get` in interface `org.mozilla.javascript.Scriptable`
Overrides:
  `get` in class `org.mozilla.javascript.ScriptableObject`

### jsFunction_toString

public Object jsFunction_toString()

### toString

public String toString()

Overrides:
  `toString` in class `Object`

### unwrap

public Object unwrap()

Specified by:
  `unwrap` in interface `org.mozilla.javascript.Wrapper`

### getStaticType

protected Class<?> getStaticType()

Specified by:
  `getStaticType` in class `ScriptableBase`
Returns:
  the static type to use for NativeJavaObject wrapping

### getWrappedObject

protected Object getWrappedObject()

Specified by:
  `getWrappedObject` in class `ScriptableBase`
Returns:
  the Java object that we're wrapping, used to create a NativeJavaObject instance for default wrapping.